/*
 * include/asm-sw_64/serial.h
 */


/*
 * This assumes you have a 1.8432 MHz clock for your UART.
 *
 * It'd be nice if someone built a serial card with a 24.576 MHz
 * clock, since the 16550A is capable of handling a top speed of 1.5
 * megabits/second; but this requires the faster clock.
 */
#ifdef CONFIG_SW_HIGOS
	#define BASE_BAUD (24000000 / 16)
#else
	#define BASE_BAUD (1843200 / 16)
#endif

/* Standard COM flags (except for COM4, because of the 8514 problem) */
#ifdef CONFIG_SERIAL_8250_DETECT_IRQ
#define STD_COM_FLAGS (UPF_BOOT_AUTOCONF | UPF_SKIP_TEST | UPF_AUTO_IRQ)
#define STD_COM4_FLAGS (UPF_BOOT_AUTOCONF | UPF_AUTO_IRQ)
#else
#define STD_COM_FLAGS (UPF_BOOT_AUTOCONF | UPF_SKIP_TEST)
#define STD_COM4_FLAGS UPF_BOOT_AUTOCONF
#endif

#if 0  /* Just for SWICH arch legacy IO test */
#if defined(CONFIG_PCI1)
#define SERIAL_PORT_DFNS                        \
     /* UART CLK        PORT   IRQ                FLAGS        */                      \
	{ 0, BASE_BAUD, 0x3F8, SW_PCIE1_INT_BASE, STD_COM_FLAGS },      /* ttyS0 */     \
	{ 0, BASE_BAUD, 0x2F8, SW_PCIE1_INT_BASE, STD_COM_FLAGS },      /* ttyS1 */
#elif defined(CONFIG_PCI0)
#define SERIAL_PORT_DFNS                        \
	     /* UART CLK        PORT   IRQ                FLAGS        */              \
	{ 0, BASE_BAUD, 0x3F8, SW_PCIE0_INT_BASE, STD_COM_FLAGS },      /* ttyS0 */    \
	{ 0, BASE_BAUD, 0x2F8, SW_PCIE0_INT_BASE, STD_COM_FLAGS },      /* ttyS1 */
#endif
#endif

#if !defined(CONFIG_SWICH) && !defined(CONFIG_SICH)
#if defined(CONFIG_SW_LIONROCK)
#define SERIAL_PORT_DFNS		\
	{ 0, BASE_BAUD, 0x3F8, 4, STD_COM_FLAGS },      /* ttyS0 */
#elif defined(CONFIG_SW_HIGOS)
#define SERIAL_PORT_DFNS			\
     /* UART CLK        PORT   IRQ FLAGS        */			\
	{ 0, BASE_BAUD, 0x500, 4, STD_COM_FLAGS },	/* ttyS0 */	\
	{ 0, BASE_BAUD, 0x2F8, 3, STD_COM_FLAGS },	/* ttyS1 */	\
	{ 0, BASE_BAUD, 0x3E8, 4, STD_COM_FLAGS },	/* ttyS2 */	\
	{ 0, BASE_BAUD, 0x2E8, 3, STD_COM4_FLAGS },	/* ttyS3 */
#elif defined(CONFIG_SW_QEMU)
#define SERIAL_PORT_DFNS            \
     /* UART CLK        PORT   IRQ FLAGS        */          \
    { 0, BASE_BAUD, 0x3F8, 12, STD_COM_FLAGS }, /* ttyS0 */
#else
#define SERIAL_PORT_DFNS                        \
     /* UART CLK        PORT   IRQ FLAGS        */                      \
	{ 0, BASE_BAUD, 0x3F8, 4, STD_COM_FLAGS },      /* ttyS0 */     \
	{ 0, BASE_BAUD, 0x2F8, 3, STD_COM_FLAGS },      /* ttyS1 */     \
	{ 0, BASE_BAUD, 0x3E8, 4, STD_COM_FLAGS },      /* ttyS2 */     \
	{ 0, BASE_BAUD, 0x2E8, 3, STD_COM4_FLAGS },     /* ttyS3 */
#endif
#endif
#ifdef CONFIG_LPC_SICH
#define SERIAL_PORT_DFNS                        \
	/* UART CLK     PORT   IRQ FLAGS        */                      \
	{ 0, BASE_BAUD, 0x3F8, 0, STD_COM_FLAGS },      /* ttyS0 */     \
	{ 0, BASE_BAUD, 0x2F8, 0, STD_COM_FLAGS },      /* ttyS1 */
#endif

