/*
 * =====================================================================================
 *       Filename:  sleep.h
 *    Description:  for suspend hibernation stuff
 *        Created:  2013年08月23日 20时04分16秒
 * =====================================================================================
 */

#ifndef _SW_SLEEP_H
#define _SW_SLEEP_H

#include <asm/pal.h>
#include <asm/ptrace.h>
#define SOFTINF_SLEEP_MAGIC 0x0123456789ABCDEFUL

#ifdef CONFIG_HIBERNATION
#include <asm/vcpu.h>
#endif

struct processor_state {
    struct pt_regs regs;
    struct switch_stack stack;
#ifdef CONFIG_HIBERNATION
    struct pcb_struct pcb;
    struct vcpucb vcb;
#endif
};
extern inline void sw_64_enable_sleep_interrupt_self(void)
{
    sleepen();
}
extern inline void sw_64_enable_mt_interrupt_self(void)
{
    mtinten();
}
extern void send_sleep_interrupt(int vcpuid);
extern void send_wakeup_interrupt(int vcpuid);

extern void sw_64_suspend_deep_sleep(struct processor_state *state);
#endif /* _SW_SLEEP_H */
